# coding: utf-8
"""
"""

import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter


def datapanel(context, main=None, session=None):

    data = {
        "datapanel": {
            "tab": []
        }
    }

    tab1 = {
        "@id": 1,
        "@name": u"Комплексные ДПП",
        "element": []
    }
    # для УМК КДПП
    tab2 = {
        "@id": 2,
        "@name": u"Учебное содержание",
        "element": []
    }

    complexProgramGrid = {
        "@id": "complexProgramGrid",
        "@type": "grid",
        "@subtype": "JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc": "umk.grid.complexProgramGrid.gridData.celesta",
        "@hideOnLoad": "false",
        "proc": [
            {
                "@id": "proc1",
                "@name": "umk.grid.complexProgramGrid.gridMeta.celesta",
                "@type": "METADATA"
            },
            {
                "@id": "proc2",
                "@name": "umk.grid.complexProgramGrid.gridToolBar.celesta",
                "@type": "TOOLBAR"
            }
        ]
    }

    complexProgramCard = {
        "@id": "complexProgramCard",
        "@type": "xforms",
        "@proc": "umk.xform.complexProgramCard.cardData.celesta",
        "@template": "umk/complexProgramCard.xml",
        "@hideOnLoad": "true",
        "proc": {
            "@id": "save",
            "@name": "umk.xform.complexProgramCard.cardSave.celesta",
            "@type": "SAVE"
        },
        "related": {
            "@id": "complexProgramGrid"
        }
    }

    complexProgramDeleteCard = {
        "@id": "complexProgramDeleteCard",
        "@type": "xforms",
        "@proc": "umk.xform.complexProgramCard.deleteCardData.celesta",
        "@template": "delElementStandardCard.xml",
        "@hideOnLoad": "true",
        "proc": {
            "@id": "save",
            "@name": "umk.xform.complexProgramCard.deleteCardSave.celesta",
            "@type": "SAVE"
        },
        "related": {
            "@id": "complexProgramGrid"
        }
    }

    umkVersionGrid = {
        "@id": "umkVersionGrid",
        "@type": "grid",
        "@subtype": "JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc": "umk.grid.umkVersionGrid.gridData.celesta",
        "@hideOnLoad": "true",
        "proc": [
            {
                "@id": "umkVersionGridMeta",
                "@name": "umk.grid.umkVersionGrid.gridMeta.celesta",
                "@type": "METADATA"
            },
            {
                "@id": "umkVersionGridToolbar",
                "@name": "umk.grid.umkVersionGrid.gridToolBar.celesta",
                "@type": "TOOLBAR"
            }
        ],
        "related": {
            "@id": "complexProgramGrid"
        }
    }

    umkVersionCard = {
        "@id": "umkVersionCard",
        "@type": "xforms",
        "@proc": "umk.xform.umkVersionCard.cardData.celesta",
        "@template": "umk/umkVersionCard.xml",
        "proc": {
            "@id": "addAttrCardSave",
            "@name": "umk.xform.umkVersionCard.cardSave.celesta",
            "@type": "SAVE"
        },
        "@hideOnLoad": "true",
        "related": {
            "@id": "complexProgramGrid"
        }
    }

    umkDeleteFromVersionGrid = {
        "@id": "umkDeleteFromVersionGrid",
        "@type": "xforms",
        "@proc": "umk.xform.umkVersionCard.deleteCardData.celesta",
        "@template": "delElementStandardCard.xml",
        "proc": {
            "@id": "umkDeleteFromVersionGridSave",
            "@name": "umk.xform.umkVersionCard.deleteCardSave.celesta",
            "@type": "SAVE"
        },
        "@hideOnLoad": "true",
        "related": {
            "@id": "umkVersionGrid"
        }
    }

    changeUmkVersionStatusCard = {
        "@id": "changeUmkVersionStatusCard",
        "@type": "xforms",
        "@proc": "umk.xform.changeUmkVersionStatusCard.cardData.celesta",
        "@template": "changeStatusStandardCard.xml",
        "proc": {
            "@id": "changeUmkVersionStatusCardSave",
            "@name": "umk.xform.changeUmkVersionStatusCard.cardSave.celesta",
            "@type": "SAVE"
        },
        "@hideOnLoad": "true",
        "related": {
            "@id": "umkVersionGrid"
        }
    }

    complexProgramAttributeGrid = {
        "@id": "complexProgramAttributeGrid",
        "@type": "grid",
        "@subtype": "JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc": "umk.grid.complexProgramAttributeGrid.gridData.celesta",
        "@hideOnLoad": "true",
        "proc": [
            {
                "@id": "umkVersionGridMeta",
                "@name": "umk.grid.complexProgramAttributeGrid.gridMeta.celesta",
                "@type": "METADATA"
            }
        ],
        "related": {
            "@id": "complexProgramGrid"
        }
    }
    # КДПП
    tab1["element"].append(complexProgramGrid)
    tab1["element"].append(complexProgramDeleteCard)
    tab1["element"].append(complexProgramCard)
    # Версии УМК
    tab1["element"].append(umkVersionGrid)
    tab1["element"].append(umkVersionCard)
    tab1["element"].append(umkDeleteFromVersionGrid)
    tab1["element"].append(changeUmkVersionStatusCard)
    # атрибуты КДПП
    tab1["element"].append(complexProgramAttributeGrid)
    # учебное содержание
    eduContentGrid = {
        "@id": "eduContentGrid",
        "@type": "grid",
        "@subtype": "JS_TREE_GRID",
        "@plugin": "treeDGrid",
        "@proc": "umk.grid.eduContentGrid.getTree.celesta",
        "@hideOnLoad": "false",
        "proc": {
            "@id": "UCgeneralGridToolbar",
            "@name": "umk.grid.eduContentGrid.gridToolBar.celesta",
            "@type": "TOOLBAR"
        }
    }

    eduContentCard = {
        "@id": "eduContentCard",
        "@type": "xforms",
        "@proc": "umk.xform.eduContentCard.cardData.celesta",
        "@template": "umk/eduContentCard.xml",
        "proc": {
            "@id": "addUCGeneralCardSave",
            "@name": "umk.xform.eduContentCard.cardSave.celesta",
            "@type": "SAVE"
        },
        "@hideOnLoad": "true",
        "related": {
            "@id": "eduContentGrid"
        }
    }

    deleteFromEduContentGrid = {
        "@id": "deleteFromEduContentGrid",
        "@type": "xforms",
        "@proc": "umk.xform.eduContentCard.deleteCardData.celesta",
        "@template": "delElementStandardCard.xml",
        "proc": {
            "@id": "umkDeleteFromUCgeneralGridSave",
            "@name": "umk.xform.eduContentCard.deleteCardSave.celesta",
            "@type": "SAVE"
        },
        "@hideOnLoad": "true",
        "related": {
            "@id": "eduContentGrid"
        }
    }
    u""" нужно исправить!!!!"""
    eduContentUploadCard = {
        "@id": "eduContentUploadCard",
        "@type": "xforms",
        "@proc": "umk.xform.eduContentUploadCard.cardData.celesta",
        "@template": "umk/eduContentUploadCard.xml",
        "proc": [
            {
                "@id": "addUCGeneralCardSave",
                "@name": "umk.xform.eduContentUploadCard.cardSave.celesta",
                "@type": "SAVE"
            },
            {
                "@id": "addUCGeneralCardUpload",
                "@name": "umk.xform.eduContentUploadCard.cardUpload.celesta",
                "@type": "UPLOAD"
            }
        ],
        "@hideOnLoad": "true",
        "related": {
            "@id": "eduContentGrid"
        }
    }

    courseModuleGrid = {
        "@id": "courseModuleGrid",
        "@type": "grid",
        "@subtype": "JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc": "edu.grid.courseModuleGrid.gridData.celesta",
        "@hideOnLoad": "true",
        "proc": [
            {
                "@id": "proc1",
                "@name": "edu.grid.courseModuleGrid.gridMeta.celesta",
                "@type": "METADATA"
            },
            # {
            #     "@id": "proc2",
            #     "@name": "edu.grid.courseModuleGrid.gridToolBar.celesta",
            #     "@type": "TOOLBAR"
            # }
        ],
        "related": {
            "@id": "eduContentGrid"
        }
    }

    tab2["element"].append(eduContentGrid)
    tab2["element"].append(eduContentCard)
    tab2["element"].append(deleteFromEduContentGrid)
    tab2["element"].append(eduContentUploadCard)
    tab2["element"].append(courseModuleGrid)

    # для перехода в режим
    if "toUmkFromUmkGrid" in context.getData():
        tab2["@id"] = 1
        data["datapanel"]["tab"].extend([tab2])
        del context.getData()["toUmkFromUmkGrid"]
    else:
        data["datapanel"]["tab"].extend([tab1])

    return XMLJSONConverter.jsonToXml(json.dumps(data))
