# coding: utf-8

from java.util import ArrayList
import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import cprogram_specializationCursor


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''ListAndCount для cprogram_specialization'''

    cprogram_id = json.loads(XMLJSONConverter.xmlToJson(params))['schema']['filter']['complex_program_id']
    cprogram_specialization = cprogram_specializationCursor(context)
    cprogram_specialization.orderBy('name')
    cprogram_specialization.setRange('complex_program_id', cprogram_id)
    cprogram_specialization.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    cprogram_specialization.limit(firstRecord, recordCount)

    count = cprogram_specialization.count()

    recordList = ArrayList()
    for row in cprogram_specialization.iterate():
        record = DataRecord()
        record.id = str(row.uid)
        record.name = row.name
        recordList.add(record)

    return ResultSelectorData(recordList, count)
