# coding: utf-8
'''
Селектор специальностей
'''
from java.util import ArrayList

from nci._nci_orm import education_levelCursor
from umk._umk_orm import specialityCursor

try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.jython import JythonDownloadResult
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):

    data = procList(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount)
    count = procCount(context, main, add, filterinfo, session, params, curValue, startsWith)
    return ResultSelectorData(data.getDataRecordList(), count.getCount())


def procListAndCount2(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''Без education_level'''
    data = procList2(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount)
    count = procCount(context, main, add, filterinfo, session, params, curValue, startsWith)
    return ResultSelectorData(data.getDataRecordList(), count.getCount())


def procCount(context, main, add, filterinfo, session, params, curValue, startsWith):

    speciality = specialityCursor(context)
    speciality.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
#     speciality.setRange('education_level',4)
    speciality.setRange('is_actual', True)
    count = speciality.count()

    return ResultSelectorData(None, count)


def procList(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount):

    speciality = specialityCursor(context)
    education_level = education_levelCursor(context)
    speciality.orderBy('name')
    speciality.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
#     speciality.setRange('education_level',4)
    speciality.setRange('is_actual', True)

    speciality.limit(firstRecord, recordCount)
    recordList = ArrayList()
    for speciality in speciality.iterate():
        rec = DataRecord()
        rec.id = str(speciality.uid)
        if speciality.education_level:
            education_level.get(speciality.education_level)
            rec.addParameter('education_level', unicode(education_level.name))
            name = u'%s (%s)' % (speciality.name, education_level.name)
        else:
            rec.addParameter('education_level', '')
            name = speciality.name
        rec.name = name
        recordList.add(rec)

    return ResultSelectorData(recordList, 0)


def procList2(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount):
    speciality = specialityCursor(context)
    speciality.orderBy('name')
    speciality.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    speciality.setRange('is_actual', True)

    speciality.limit(firstRecord, recordCount)
    recordList = ArrayList()
    for speciality in speciality.iterate():
        rec = DataRecord()
        rec.id = str(speciality.uid)
        rec.addParameter('education_level', '')
        name = speciality.name
        rec.name = name
        recordList.add(rec)

    return ResultSelectorData(recordList, 0)
